/* $Id: I2L_rules.j,v 1.6 2002/09/30 11:12:01 richard Exp $ */

/* these rules are stated without an explicit left-context . This makes them more friendly
 * to the innocent natural-deductionist (:-)), or so we hope. The initialisation of autoAdditiveLeft
 * in I2L_syntax.j is what does the magic.
 */
 
TACTIC Fail (x) IS SEQ (ALERT x) STOP

RULE cut(B) IS FROM B AND B  C INFER C
RULE thin(A) IS FROM C INFER A  C

RULE "e" IS FROM AB AND A INFER B
RULE "e1" IS FROM A  B INFER A
RULE "e2" IS FROM A  B INFER B
RULE "e" IS FROM A  B AND A  C AND B  C INFER C
RULE "e" IS FROM  INFER B
RULE "e" IS FROM A INFER A
RULE "e1" IS FROM AB INFER AB
RULE "e2"  IS FROM AB INFER BA
RULE "e" IS FROM x. P(x) AND actual i INFER P(i)
RULE "e"(OBJECT i) WHERE FRESH i AND i NOTIN x.P(x) IS FROM x.P(x) AND actual i, P(i)  C INFER C

RULE "i" IS FROM A  B INFER AB
RULE "i" IS FROM A AND B INFER A  B
RULE "i1"(B) IS FROM A INFER A  B
RULE "i2"(B) IS FROM A INFER B  A
RULE "i" IS FROM A   INFER A
RULE "i" IS FROM AB AND BA INFER AB
RULE "e"(B) IS FROM B AND B INFER 
RULE "i"(OBJECT i) WHERE FRESH i IS FROM actual i  P(i) INFER x .P(x)
RULE "i" IS FROM P(i) AND actual i INFER x.P(x)

/* Reglas derivadas */
RULE "MT"(A)  IS FROM B AND AB INFER A
RULE "i" IS FROM A INFER A
RULE "RAA" IS FROM A   INFER A
RULE "LEM"(A) IS INFER A  A 

RULE hyp(A) IS INFER A  A
AUTOMATCH hyp

IDENTITY  hyp
CUT		cut
WEAKEN	  thin

/* no longer used
RULE "inscope"(x) IS INFER actual x  x inscope
AUTOMATCH "inscope"
 */
